
#include <helianthus-nk.h>

#include "nuklear-demos/calculator.c"
#include "nuklear-demos/canvas.c"
#include "nuklear-demos/node_editor.c"
#include "nuklear-demos/overview.c"


nk_heli hnk;
struct nk_context *nk;

Animation anim;
struct nk_image img;


void init() {
  nk_heli_init(&hnk, 12);
  nk = &hnk.context;
  anim = createAnimation("data/sprite/breadball.png");
  img = nk_heli_image(anim, 64, 64);
}


void deinit() {
  nk_heli_deinit(&hnk);
}


void draw() {
  calculator(nk);
  canvas(nk);
  node_editor(nk);
  overview(nk, img);
  nk_heli_process(&hnk);
}


int main() {
  windowSetTitle("Nuklear UI Demo");
  windowSetResizable(TRUE);
  windowSetVariableFrameRate();
  windowSetInit(&init);
  windowSetDeinit(&deinit);
  windowSetDraw(&draw);
  windowRun();
  return 0;
}

