#ifndef HELI_COMMON_H
#define HELI_COMMON_H


#ifndef TRUE
#define TRUE  1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef PI
#define PI 3.14159265358979323846
#endif


typedef struct _Directory *Directory;


int randomNumber(int min, int max);
double randomFloat();

void rotateVector(double *x, double *y, double angle);


Directory openDirectory(const char *path);
Directory openDirectoryEx(
	const char *path,
	const char *prefix,
	const char *suffix,
	int caseSensitive,
	int showFiles,
	int showDirectories );
void closeDirectory(Directory directory);
int directoryGetCount(Directory directory);
const char* directoryGet(Directory directory, int i);
const char* directoryGetFull(Directory directory, int i);

int fileExists(const char *path);
int directoryExists(const char *path);


#endif
